{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs {
          inherit system;
          config.allowUnfree = true;
        };
        lib = pkgs.lib;

        shellWithPkgs = buildInputs: pkgs.mkShell {
          inherit buildInputs;
        };
      in
      {
        devShells.default = shellWithPkgs (lib.singleton pkgs.codeql);
      });
}


